%define popIF_ver_gt() %if "%(rpmvercmp '%1' '%2')" > "0"
%define popIF_ver_gteq() %if "%(rpmvercmp '%1' '%2')" >= "0"
%define popIF_ver_lt() %if "%(rpmvercmp '%2' '%1')" > "0"
%define popIF_ver_lteq() %if "%(rpmvercmp '%2' '%1')" >= "0"

%def_disable static
%def_enable qt4
%def_enable qt3

%define rname poppler
%define sffx %nil
Name: %rname%sffx
Version: 0.6.3
Release: alt1

%define is06 0
%popIF_ver_gt "%version" "0.5.9"
%popIF_ver_lt "%version" "0.6.9"
%define is06 1
%endif
%endif

Group: Publishing
Summary: PDF rendering library
License: GPL
Url: http://poppler.freedesktop.org/
Packager: Sergey V Turchin <zerg at altlinux dot org>

Requires: lib%name = %version-%release
%if "%sffx" != "%nil"
Provides: %rname = %version-%release
Obsoletes: %rname < %version-%release
%else
%if %is06
Provides: poppler0.6 = %version-%release
Obsoletes: poppler0.6 < %version-%release
%endif
%endif
Provides: xpdf-utils = 3.02-alt3
Conflicts: xpdf-utils
Conflicts: xpdf-reader <= 3.02-alt3

Source: %rname-%version.tar
Patch1: poppler-0.5.9-alt-qt.patch

BuildRequires: fontconfig-devel freetype2-devel gcc-c++ glib2-devel rpm-utils
%if_enabled qt3
BuildRequires: glibc-devel-static
%endif
BuildRequires: xorg-x11-devel libatk-devel libcairo-devel libgtk+2-devel
BuildRequires: libjpeg-devel libpango-devel libstdc++-devel pkg-config zlib-devel
%if_enabled qt3
BuildRequires: libqt3-devel
%endif
%if_enabled qt4
BuildRequires: libqt4-devel
%endif

%description
Poppler is a fork of the xpdf PDF viewer developed by Derek Noonburg
of Glyph and Cog, LLC.  The purpose of forking xpdf is twofold.
First, we want to provide PDF rendering functionality as a shared
library, to centralize the maintenence effort.  Today a number of
applications incorporate the xpdf code base, and whenever a security
issue is discovered, all these applications exchange patches and put
out new releases.  In turn, all distributions must package and release
new version of these xpdf based viewers.  It's safe to say that
there's a lot of duplicated effort with the current situaion.  Even if
poppler in the short term introduces yet another xpdf derived code
base to the world, we hope that over time these applications will
adopt poppler.  After all, we only need one application to use poppler
to break even.

%package -n lib%{name}
Summary: PDF rendering library
Group: System/Libraries
Requires: poppler-data
%if %is06
Provides: libpoppler0.6 = %version-%release
Obsoletes: libpoppler0.6 < %version-%release
%endif
%description -n lib%{name}
Poppler is a fork of the xpdf PDF viewer developed by Derek Noonburg
of Glyph and Cog, LLC.  The purpose of forking xpdf is twofold.
First, we want to provide PDF rendering functionality as a shared
library, to centralize the maintenence effort.  Today a number of
applications incorporate the xpdf code base, and whenever a security
issue is discovered, all these applications exchange patches and put
out new releases.  In turn, all distributions must package and release
new version of these xpdf based viewers.  It's safe to say that
there's a lot of duplicated effort with the current situaion.  Even if
poppler in the short term introduces yet another xpdf derived code
base to the world, we hope that over time these applications will
adopt poppler.  After all, we only need one application to use poppler
to break even.

%package -n lib%{name}-qt
Summary: Qt3 frontend library for %name
Group: System/Libraries
Requires: lib%name = %version-%release
%if %is06
Provides: libpoppler0.6-qt = %version-%release
Obsoletes: libpoppler0.6-qt < %version-%release
%endif
%description -n lib%{name}-qt
Qt3 frontend library for %name

%package -n lib%{name}-qt4
Summary: Qt4 frontend library for %name
Group: System/Libraries
Requires: lib%name = %version-%release
Requires: libqt4-core >= %{get_version libqt4-core}
%if %is06
Provides: libpoppler0.6-qt4 = %version-%release
Obsoletes: libpoppler0.6-qt4 < %version-%release
%endif
%description -n lib%{name}-qt4
Qt4 frontend library for %name

%package -n lib%{name}-glib
Summary: Glib frontend library for %name
Group: System/Libraries
Requires: lib%name = %version-%release
%if %is06
Provides: libpoppler0.6-glib = %version-%release
Obsoletes: libpoppler0.6-glib < %version-%release
%endif
%description -n lib%{name}-glib
Glib frontend library for %name

%package -n lib%{name}-devel
Summary: Development files for %name
Group: Development/C
%if "%sffx" != "%nil"
Provides: lib%rname-devel = %version-%release
Obsoletes: lib%rname-devel < %version-%release
%else
%if %is06
Provides: libpoppler0.6-devel = %version-%release
Obsoletes: libpoppler0.6-devel < %version-%release
%endif
%endif
Requires: lib%name = %version-%release
%description -n lib%{name}-devel
Libraries, include files, etc you can use to develop poppler applications

%package -n lib%{name}-glib-devel
Summary: Development files for %name-glib
Group: Development/GNOME and GTK+
%if "%sffx" != "%nil"
Provides: lib%rname-glib-devel = %version-%release
Obsoletes: lib%rname-glib-devel < %version-%release
%else
%if %is06
Provides: libpoppler0.6-glib-devel = %version-%release
Obsoletes: libpoppler0.6-glib-devel < %version-%release
%endif
%endif
Requires: lib%name-glib = %version-%release
Requires: lib%name-devel = %version-%release
%description -n lib%{name}-glib-devel
Libraries, include files, etc you can use to develop
poppler applications with Glib/Gtk+

%package -n lib%{name}-qt-devel
Summary: Development files for %name-qt
Group: Development/KDE and QT
%if "%sffx" != "%nil"
Provides: lib%rname-qt-devel = %version-%release
Obsoletes: lib%rname-qt-devel < %version-%release
%else
%if %is06
Provides: libpoppler0.6-qt-devel = %version-%release
Obsoletes: libpoppler0.6-qt-devel < %version-%release
%endif
%endif
Requires: lib%name-qt = %version-%release
Requires: lib%name-devel = %version-%release
%description -n lib%{name}-qt-devel
Libraries, include files, etc you can use to develop
poppler applications with Qt3

%package -n lib%{name}-qt4-devel
Summary: Development files for %name-qt4
Group: Development/KDE and QT
%if "%sffx" != "%nil"
Provides: lib%rname-qt4-devel = %version-%release
Obsoletes: lib%rname-qt4-devel < %version-%release
%else
%if %is06
Provides: libpoppler0.6-qt4-devel = %version-%release
Obsoletes: libpoppler0.6-qt4-devel < %version-%release
%endif
%endif
Requires: lib%name-qt4 = %version-%release
Requires: lib%name-devel = %version-%release
%description -n lib%{name}-qt4-devel
Libraries, include files, etc you can use to develop
poppler applications with Qt4

%package -n lib%{name}-devel-static
Summary: Static libraries for libpoppler
Group: Development/Other
%if "%sffx" != "%nil"
Provides: lib%rname-devel-static = %version-%release
Obsoletes: lib%rname-devel-static < %version-%release
%else
%if %is06
Provides: libpoppler0.6-devel-static = %version-%release
Obsoletes: libpoppler0.6-devel-static < %version-%release
%endif
%endif
Requires: lib%name-devel = %version-%release
%description -n lib%{name}-devel-static
This package contains development libraries required for packaging
statically linked libpoppler-based software


%prep
%setup -q -n %rname-%version
%patch1 -p1
%__autoreconf


%build
export QT3DIR=%_qt3dir QT4DIR=%_qt4dir
%configure \
    --disable-rpath \
    --enable-shared \
    %{subst_enable static} \
    --enable-dependency-tracking \
    --enable-compile-warnings=yes \
    --enable-xpdf-headers \
    --enable-zlib \
%if_disabled qt3
    --disable-poppler-qt \
%endif
%if_disabled qt4
    --disable-poppler-qt4 \
%endif
    --enable-a4-paper

%make_build


%install
%makeinstall
[ -f %buildroot/%_pkgconfigdir/poppler-cairo.pc ] || \
    touch %buildroot/%_pkgconfigdir/poppler-cairo.pc


%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig
#
%post -n lib%{name}-qt -p %post_ldconfig
%postun -n lib%{name}-qt -p %postun_ldconfig
#
%post -n lib%{name}-qt4 -p %post_ldconfig
%postun -n lib%{name}-qt4 -p %postun_ldconfig
#
%post -n lib%{name}-glib -p %post_ldconfig
%postun -n lib%{name}-glib -p %postun_ldconfig


%files
%_bindir/*
%_man1dir/*

%files -n lib%name
%doc AUTHORS ChangeLog NEWS README* TODO
%_libdir/libpoppler.so.*

%files -n lib%{name}-glib
%_libdir/libpoppler-glib.so.*

%if_enabled qt3
%files -n lib%{name}-qt
%_libdir/libpoppler-qt.so.*
%endif

%if_enabled qt4
%files -n lib%{name}-qt4
%_libdir/libpoppler-qt4.so.*
%endif

%files -n lib%{name}-devel
%dir %_includedir/poppler
%_includedir/poppler/*.h
%_includedir/poppler/Function.cc
%_includedir/poppler/splash/
%_includedir/poppler/goo/
%_libdir/libpoppler.so
%_pkgconfigdir/poppler.pc
%_pkgconfigdir/poppler-splash.pc
#%_datadir/gtk-doc/html/poppler

%files -n lib%{name}-glib-devel
%_includedir/poppler/glib/
%_libdir/libpoppler-glib.so
%_pkgconfigdir/poppler-cairo.pc
%_pkgconfigdir/poppler-glib.pc

%if_enabled qt3
%files -n lib%{name}-qt-devel
%_includedir/poppler/qt3/
%_libdir/libpoppler-qt.so
%_pkgconfigdir/poppler-qt.pc
%endif

%if_enabled qt4
%files -n lib%{name}-qt4-devel
%_includedir/poppler/qt4/
%_libdir/libpoppler-qt4.so
%_pkgconfigdir/poppler-qt4.pc
%endif

%if_enabled static
%files -n lib%{name}-devel-static
%_libdir/*.a
%endif

%changelog
* Thu Dec 27 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.3-alt1
- new version

* Thu Nov 08 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt3
- add patch to fix CVE-2007-4352, CVE-2007-5392, CVE-2007-5393

* Wed Oct 17 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt2
- fix tarball

* Fri Oct 12 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt1
- new version

* Mon Oct 08 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt6
- fix provides/obsoletes

* Mon Oct 08 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt5
- replace poppler-0.5

* Wed Sep 26 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt4
- include unsupported xpdf headers into devel package

* Mon Sep 24 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt3
- add obsoletes instead conflicts

* Wed Sep 19 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt2
- provide devel packages to override poppler-devel-0.5

* Tue Sep 04 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6-alt1
- new version

* Mon Aug 06 2007 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt6
- add patch to fix CVE-2007-3387

* Mon Jun 25 2007 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt5
- fix %%files intersections (#11804)

* Wed Nov 01 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt4
- fix patch for cairo

* Tue Oct 31 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt3
- fix compile with cairo < 0.9

* Tue Oct 03 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt2
- fix find Qt4 on x86_64

* Mon Oct 02 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.4-alt1
- new version
- built with Qt4

* Mon Jul 17 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.3-alt1
- new version

* Mon Jun 05 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.1-alt2
- built without Qt4

* Tue May 16 2006 Sergey V Turchin <zerg at altlinux dot org> 0.5.1-alt1
- new version
- fix %%files in -devel subpackages
- built with Qt4

* Fri Mar 31 2006 Sergey V Turchin <zerg at altlinux dot org> 0.4.5-alt2
- fix lib*.so list in *-devel packages

* Tue Feb 14 2006 ALT QA Team Robot <qa-robot@altlinux.org> 0.4.5-alt1
- Updated to 0.4.5.
- Cleaned up the spec a bit.

* Wed Feb 08 2006 Sergey V Turchin <zerg at altlinux dot org> 0.4.4-alt2
- fix linking with qt
- split qt,glib,devel libraries to subpackages
- fix %%url
- fix requires
- fix build requires

* Thu Feb 02 2006 ALT QA Team Robot <qa-robot@altlinux.org> 0.4.4-alt1.1
- Rebuilt for new pkg-config dependencies.

* Wed Jan 11 2006 Andrey Semenov <mitrofan@altlinux.ru> 0.4.4-alt1
- new  version

* Tue Dec 13 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.4.3-alt1
- new version

* Mon Sep 05 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.4.2-alt1
- 0.4.2

* Mon Aug 29 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.4.1-alt1
- new version

* Tue Jun 21 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.3.3-alt1
- 0.3.3

* Mon Jun 06 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.3.2-alt2
- Change package summary

* Wed May 25 2005 Andrey Semenov <mitrofan@altlinux.ru> 0.3.2-alt1
- First version of RPM

